#include <LiquidCrystal_I2C.h>
#include <ds3231.h>


struct ts t;  // start time
struct ts t_player; 
LiquidCrystal_I2C lcd(0x27,16,2);
const int nivel_maxim = 10;
int secventa[nivel_maxim];
int sunet[nivel_maxim];
int secventa_jucator[nivel_maxim];
int nivel = 2;
int note = 0;
int velocity = 2000;
int start = 0;
int score = 0;
 
void setup() {   //declaram pinii
  pinMode(13, OUTPUT); //led galben
  pinMode(12, OUTPUT); //led rosu
  pinMode(11, OUTPUT); //led verde
  pinMode(10, OUTPUT); //led albastru
 
  pinMode(7, INPUT_PULLUP); //buton 1
  pinMode(6, INPUT_PULLUP); //buton 2
  pinMode(5, INPUT_PULLUP); //buton 3
  pinMode(4, INPUT_PULLUP); //buton 4
 
  pinMode(3, OUTPUT); //buzzer
  lcd.init();
  lcd.backlight();
  lcd.setCursor(1, 0);
  lcd.print("Press any key");
  lcd.setCursor(4, 1);  
  lcd.print("to start");
  DS3231_init(DS3231_CONTROL_INTCN);
  t.hour = 0; t.min = 0; t.sec = 0; t.mday = 1; t.mon = 1; t.year = 0;
  DS3231_set(t);
}
 

 
void generare_secventa() {
  randomSeed(millis());
 
  for (int i = 0; i < nivel; i++) {
    secventa[i] = random(10, 14);
  }
}
 
void show_secventa() {
  digitalWrite(13, LOW);
  digitalWrite(12, LOW);
  digitalWrite(11, LOW);
  digitalWrite(10, LOW);
 
  for (int i = 0; i < nivel; i++) {
    digitalWrite(secventa[i], HIGH);
    delay(velocity);
    digitalWrite(secventa[i], LOW);
    delay(500);
  }
}
 
void get_secventa() {
  int flag = 0; //flag - secventa corecta
  DS3231_get(&t);
  for (int i = 0; i < nivel; i++) {
    flag = 0;
 
    while (flag == 0) {
      DS3231_get(&t_player);
      if (t.min != t_player.min && (60 - t.sec + t_player.sec) > 20) {
        lcd.clear();
        lcd.setCursor(4, 0);
        lcd.print("Time's up!");
        delay(3000);
        secventa_gresita();
        return ;
      } else if (t.min == t_player.min && (t.sec - t_player.sec) > 20) {
        lcd.clear();
        lcd.setCursor(4, 0);
        lcd.print("Time's up!");
        delay(3000);
        secventa_gresita();
        return ;
      }
      
      if (digitalRead(7) == LOW) {
        digitalWrite(13, HIGH);
        delay(700);
        secventa_jucator[i] = 13;
        flag = 1;
        delay(200);
 
        if (secventa_jucator[i] != secventa[i]) {
          secventa_gresita();
          return ;
        }
        digitalWrite(13, LOW);
      }
 
      if (digitalRead(6) == LOW) {
        digitalWrite(12, HIGH);
        delay(700);
        secventa_jucator[i] = 12;
        flag = 1;
        delay(200);
 
        if (secventa_jucator[i] != secventa[i]) {
          secventa_gresita();
          return ;
        }
        digitalWrite(12, LOW);
      }
 
      if (digitalRead(5) == LOW) {
        digitalWrite(11, HIGH);
        delay(700);
        secventa_jucator[i] = 11;
        flag = 1;
        delay(200);
 
        if (secventa_jucator[i] != secventa[i]) {
          secventa_gresita();
          return ;
        }
        digitalWrite(11, LOW);
      }
 
      if (digitalRead(4) == LOW) {
        digitalWrite(10, HIGH);
        delay(700);
        secventa_jucator[i] = 10;
        flag = 1;
        delay(200);
 
        if (secventa_jucator[i] != secventa[i]) {
          secventa_gresita();
          return ;
        }
        digitalWrite(10, LOW);
      }
    }
  }
  secventa_corecta();
}
 
void secventa_corecta() {
  for(int i = 0; i < 2; i++) {
    digitalWrite(13, LOW);
    digitalWrite(12, LOW);
    digitalWrite(11, LOW);
    digitalWrite(10, LOW);
    tone(3, 293);
    delay(250);
 
    digitalWrite(13, HIGH);
    digitalWrite(12, HIGH);
    digitalWrite(11, HIGH);
    digitalWrite(10, HIGH);
    delay(500);
 
   digitalWrite(13, LOW);
    digitalWrite(12, LOW);
    digitalWrite(11, LOW);
    digitalWrite(10, LOW);
    noTone(3);
    delay(500);
  }
 
  if (nivel < nivel_maxim) {
    score += nivel;
    nivel++;
  }
  velocity *= 0.85; //creste dificultatea
  
}
 
void secventa_gresita() {
  for (int i = 0; i < 3; i++) {
    digitalWrite(13, HIGH);
    digitalWrite(12, HIGH);
    digitalWrite(11, HIGH);
    digitalWrite(10, HIGH);
    tone(3, 233);
    delay(250);
 
    digitalWrite(13, LOW);
    digitalWrite(12, LOW);
    digitalWrite(11, LOW);
    digitalWrite(10, LOW);
    noTone(3);
    delay(250);
  }
  lcd.clear();
  lcd.setCursor(4, 0);
  lcd.print("You lost.");
  lcd.setCursor(4, 1);
  lcd.print("Score:");
  lcd.setCursor(11, 1);
  lcd.print(score);
  delay(5000);
  lcd.clear();
  lcd.setCursor(1, 0);
  lcd.print("Press any key");
  lcd.setCursor(1, 1);
  lcd.print("to play again");
  nivel = 2;
  start = 0;
  score = 0;
  velocity = 2000;
}

void loop() {
  if (nivel == 2) {
    for (int i = 13; i >= 10; i--) { //leduri on/off
      digitalWrite(i, HIGH);
      delay(100);
      digitalWrite(i, LOW);
      if (digitalRead(7) == LOW || digitalRead(6) == LOW || digitalRead(5) == LOW || digitalRead(4) == LOW) {
        start = 1;
        break;
      }
    }
  }
 
  if (digitalRead(7) == LOW || digitalRead(6) == LOW || digitalRead(5) == LOW || digitalRead(4) == LOW || start == 1) { //butonul de start = 1
    start = 1;
    if (nivel == 2) {
      tone(3, 349);
      delay(750);
      noTone(3);
      lcd.clear();
      lcd.setCursor(4, 0);
      lcd.print("Score: ");
      lcd.setCursor(4, 1);
      lcd.print("Level: ");
    }
    lcd.setCursor(11, 0);
    lcd.print(score);
    lcd.setCursor(11, 1);
    lcd.print(nivel - 1);
    generare_secventa();
    show_secventa();
    get_secventa();
  }
}
